Attribute VB_Name = "Module1"
Option Explicit

Private Declare Sub GetSafeArrayPointer Lib "msvbvm60.dll" Alias "GetMem4" (pArray() As Any, sfaPtr As Long)

Private Declare Function CreatePipe Lib "kernel32" (phReadPipe As Long, phWritePipe As Long, lpPipeAttributes As Any, ByVal nSize As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, lpProcessAttributes As Any, lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As Any, lpProcessInformation As Any) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function PeekNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long, lpBuffer As Any, ByVal nBufferSize As Long, lpBytesRead As Long, lpTotalBytesAvail As Long, lpBytesLeftThisMessage As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Private Type SECURITY_ATTRIBUTES
  nLength As Long
  lpSecurityDescriptor As Long
  bInheritHandle As Long
End Type
      
Private Type STARTUPINFO
  cb As Long
  lpReserved As Long
  lpDesktop As Long
  lpTitle As Long
  dwX As Long
  dwY As Long
  dwXSize As Long
  dwYSize As Long
  dwXCountChars As Long
  dwYCountChars As Long
  dwFillAttribute As Long
  dwFlags As Long
  wShowWindow As Integer
  cbReserved2 As Integer
  lpReserved2 As Long
  hStdInput As Long
  hStdOutput As Long
  hStdError As Long
End Type
      
Private Type PROCESS_INFORMATION
  hProcess As Long
  hThread As Long
  dwProcessID As Long
  dwThreadID As Long
End Type

Public Type EMAILINFO
    Sender As String
    Recipient() As String
    Cc() As String
    Bcc() As String
    Subject As String
    Message As String
    Server As String
    Attachment() As String
    Username As String
    Password As String
    HTML As Boolean
End Type

Public Type EMAIL_RETURNINFO
    Success As Boolean
    Message As String
End Type
         
Private Const NORMAL_PRIORITY_CLASS = &H20&
Private Const STARTF_USESTDHANDLES = &H100&
Private Const STARTF_USESHOWWINDOW = 1

Public Function SendMail(ByRef eInfo As EMAILINFO) As EMAIL_RETURNINFO

Dim i As Long
Dim CallString As String
Dim ArrPtr As Long
Dim retText As String
Dim retVal As EMAIL_RETURNINFO

ChDir App.Path & IIf(Right$(App.Path, 1) = "\", "", "\") & "sendEmail 1.56"

CallString = "sendemail -f " & Chr$(34) & eInfo.Sender & Chr$(34) & " -s " & eInfo.Server & " -xu " & eInfo.Username & " -xp " & eInfo.Password & " -u " & Chr$(34) & eInfo.Subject & Chr(34) & " -m " & Chr$(34) & eInfo.Message & Chr$(34) & " -o message-content-type=" & IIf(eInfo.HTML = True, "html", "text")

CallString = CallString & " -t "
For i = 0 To UBound(eInfo.Recipient)
    CallString = CallString & Chr$(34) & eInfo.Recipient(i) & Chr$(34) & " "
Next

GetSafeArrayPointer eInfo.Cc(), ArrPtr
If ArrPtr <> 0 Then
    CallString = CallString & " -cc "
    For i = 0 To UBound(eInfo.Cc)
        CallString = CallString & Chr$(34) & eInfo.Cc(i) & Chr$(34) & " "
    Next
End If

GetSafeArrayPointer eInfo.Bcc(), ArrPtr
If ArrPtr <> 0 Then
    CallString = CallString & " -bcc "
    For i = 0 To UBound(eInfo.Bcc)
        CallString = CallString & Chr$(34) & eInfo.Bcc(i) & Chr$(34) & " "
    Next
End If

GetSafeArrayPointer eInfo.Attachment(), ArrPtr
If ArrPtr <> 0 Then
    CallString = CallString & " -a "
    For i = 0 To UBound(eInfo.Attachment)
        CallString = CallString & Chr$(34) & eInfo.Attachment(i) & Chr$(34) & " "
    Next
End If

retText = ShellWaitPipe(CallString)

If InStr(retText, "sent successfully") Then retVal.Success = True Else retVal.Success = False
retVal.Message = retText

SendMail = retVal

End Function

Private Function ShellWaitPipe(ByVal CmdLine As String) As String

Dim proc As PROCESS_INFORMATION
Dim start As STARTUPINFO
Dim sa As SECURITY_ATTRIBUTES
Dim hReadPipe As Long
Dim hWritePipe As Long
Dim L As Long
Dim Result As Long
Dim bSuccess As Long
Dim Buffer As String
Dim retText As String
Dim lPeekData As Long
Dim retVal As EMAIL_RETURNINFO

sa.nLength = Len(sa)
sa.bInheritHandle = 1&
sa.lpSecurityDescriptor = 0&
Result = CreatePipe(hReadPipe, hWritePipe, sa, 0)

If Result = 0 Then
    MsgBox "CreatePipe failed Error!"
    Exit Function
End If

start.cb = Len(start)
start.wShowWindow = 0
start.dwFlags = STARTF_USESHOWWINDOW Or STARTF_USESTDHANDLES
start.hStdOutput = hWritePipe

Result = CreateProcessA(0&, CmdLine$, sa, sa, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, start, proc)

If Result <> 0 Then
    Do
        Call PeekNamedPipe(hReadPipe, ByVal 0&, 0&, ByVal 0&, lPeekData, ByVal 0&)
        
        If lPeekData > 0 Then
            Buffer = Space$(lPeekData)
            bSuccess = ReadFile(hReadPipe, Buffer, Len(Buffer), L, 0&)
            
            If bSuccess = 1 Then
                retText = retText & Left(Buffer, L)
            Else
                MsgBox "ReadFile failed!"
            End If
        Else
            bSuccess = WaitForSingleObject(proc.hProcess, 0&)
                    
            If bSuccess = 0 Then Exit Do
        End If
        
        DoEvents
    Loop
        
Else
    MsgBox "Error while starting process!"
End If

Call CloseHandle(proc.hProcess)
Call CloseHandle(proc.hThread)
Call CloseHandle(hReadPipe)
Call CloseHandle(hWritePipe)

ShellWaitPipe = retText

End Function

